<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');

// Recherche de la page concernée
$mysqli = premiere_connexion();
$resultat = $mysqli->query('SELECT id, cle, titre, bandeau1, bandeau2 FROM pages');
if ( $resultat->num_rows )  {
  if ( !empty($_REQUEST) )  {
    while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $page = $r;
        break;
      }
  }
  // Page par défaut : la première
  if ( !isset($page) )  {
    $resultat->data_seek(0);
    $page = $resultat->fetch_assoc();
  }
  $resultat->free();
}
// Si pas de page enregistrée
else  {
  $mysqli->close();
  include('installation.php');
}

//////////
// HTML //
//////////
// Haut de page et menu
$p = $page['cle'];
// Si $page['titre'] est vide, donner un titre général
$t = ( strlen($page['titre']) ) ? $page['titre'] : "La $classe du lycée $lycee";
include('haut.php');
$mysqli->close();

// Pour l'interface d'administration
if ( $admin )  {
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Traitement d'un ajout/modification/transformation
  if ( isset($_REQUEST['nmodif']) && is_numeric($n = $_REQUEST['nmodif']) )  {
    // Sauvegarde de la table contenant les données
    sauvegarde_mysql('infos');

    // Transformations sans utilisation du formulaire
    if ( isset($_REQUEST['monte']) )
      $message = ( $mysqli->query("UPDATE infos SET id = 0 WHERE id = $n AND page = ${page['id']}")
                && $mysqli->query("UPDATE infos SET id = ($n-1+id/($n-1)) WHERE ( id = ($n-1) OR id = 0 ) AND page = ${page['id']} ORDER BY id DESC")
                && $mysqli->query("ALTER TABLE infos ORDER BY id,page")
      ) ? 'L\'item a bien été monté d\'une place.' : 'L\'item n\'a pas pu être déplacé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
    elseif ( isset($_REQUEST['cache']) )
      $message = ( $mysqli->query("UPDATE infos SET cache = 1 WHERE id = $n AND page = ${page['id']}") ) ? 'L\'item a bien été caché&nbsp;: il n\'apparaît plus dans la partie publique mais est toujours disponible ici pour modification ou réaffichage.' : 'L\'item n\'a pas pu être caché. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
    elseif ( isset($_REQUEST['montre']) )
      $message = ( $mysqli->query("UPDATE infos SET cache = 0 WHERE id = $n AND page = ${page['id']}") ) ? 'L\'item a bien été réaffiché&nbsp;: il apparaît à nouveau dans la partie publique.' : 'L\'item n\'a pas pu être réaffiché. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
    // Suppression
    elseif ( isset($_REQUEST['suppr']) )
      $message = ( $mysqli->query("DELETE FROM infos WHERE id = $n AND page = ${page['id']}")
                && $mysqli->query("UPDATE infos SET id = (id-1) WHERE id > $n AND page = ${page['id']}")
      ) ? 'L\'item a bien été supprimé.' : '<br>L\'item n\'a pas pu être supprimé. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
    // Ajout/modification d'un item
    else  {
      if ( isset($_REQUEST['valid_modif']) )  {
        if ( !strlen($_REQUEST['texte']) )
          $message = 'Il n\'est pas possible de valider un texte vide. Pour supprimer un item, il faut cliquer sur Supprimer.';
        else  {
          // Vérifications des données envoyées
          $t = $mysqli->real_escape_string($_REQUEST['texte']);
          $titre = $mysqli->real_escape_string($_REQUEST['titre']);
          // Si n > 0 : modification d'une info existante. Si n = 0, nouvelle info
          if ( $n )
            $message = ( $mysqli->query("UPDATE infos SET texte = '$t', titre = '$titre' WHERE id = $n AND page = ${page['id']}")
            ) ? 'L\'item a bien été modifié.' : 'L\'item n\'a pas pu être modifié. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
          else
            $message = ( $mysqli->query("UPDATE infos SET id = (id+1) WHERE page = ${page['id']} ORDER by id DESC")
                      && $mysqli->query("INSERT INTO infos SET id = 1, page = ${page['id']}, texte='$t', titre='$titre'")
                      && $mysqli->query("ALTER TABLE infos ORDER BY id,page")
            ) ? 'L\'item a bien été ajouté.' : 'L\'item n\'a pas pu être ajouté. Erreur MySQL n°'.$mysqli->errno.', «'.$mysqli->error.'».';
        }
      }
      // Lecture pour affichage dans le formulaire
      $resultat = $mysqli->query("SELECT texte,titre FROM infos where id = $n AND page = ${page['id']}");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_assoc();
        $texte = $r['texte'];
        $titre = $r['titre'];
        $resultat->free();
      }
    }
  }

  // Conditionnement du message éventuel
  $message = ( isset($message) ) ? "<p class=\"annonce\">$message</p>\n\n  " : '';

  // Initialisation des variables pour le formulaire
  if ( !isset($texte) || isset($_REQUEST['copie']) )  {
    $n = 0;
    $debut = '<h3>Nouvelle information</h3>';
    $suppr = '';
  }
  else  {
    $debut = '<h3>Modification d\'une information</h3>';
    $suppr = '<input type="submit" name="suppr" value="Supprimer">';
  }
  if ( !isset($texte) )  {
    $texte = '&lt;p&gt;Texte&lt;/p&gt;';
    $titre = '';
  }
  
  // Affichage du formulaire de modification
  echo <<<FIN
  $message<div class="item">
    <p>Vous pouvez ici ajouter une information sur cette page ou modifier celles déjà entrées (qui sont affichées en-dessous de ce formulaire).</p>
    <p>Pour créer une nouvelle page contenant des informations sur un thème précis, vous devez vous rendre sur la <a href="pages">page de modification des pages du site</a>.</p>
    <p>Toute nouvelle information apparaîtra automatiquement en haut de la page. L'ordre de l'ensemble des informations est modifiable en-dessous de ce formulaire.</p>
  </div>
  
<!-- Formulaire de modification/copie -->
  <form class="item admin" action="" method="post">
    $debut
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider">$suppr</p>
    <h4>Titre&nbsp;: <input type="text" name="titre" size=50 maxlength=65533 value="$titre"></h4>
    <h4>Information&nbsp;:</h4>
    <div>
      <textarea name="texte" rows="15" cols="100">$texte</textarea>
      <input type="hidden" name="nmodif" value="$n">
    </div>
  </form>

  <script type="text/javascript" src="js/textarea.js"></script>


FIN;

  // Affichage des items
  $resultat = $mysqli->query('SELECT id,cache,titre,texte FROM infos WHERE page = '.$page['id']);
  $mysqli->close();
  if ( $resultat->num_rows )  {
    echo <<<FIN
  <h2>Informations présentes sur cette page&nbsp;:</h2>

  <div class="item">
    <p>Il est possible de modifier l'ordre d'affichage des informations grâce aux boutons fléchés.</p>
    <p>Il est possible de «&nbsp;cacher&nbsp;» une information de la partie publique du site sans la supprimer réellement de la base de données. Cela peut être utile pour une information qui n'est plus d'actualité mais qui pourrait servir à nouveau ultérieurement.</p>
    <p>Le bouton «&nbsp;Recopier&nbsp;» récupère les données de l'information concernée et permet d'en créer une nouvelle. Les modifications effectuées dans le formulaire affectent donc la nouvelle information, l'originale reste inchangée.</p>
  </div>


FIN;
    while ( $r = $resultat->fetch_assoc() )  {
      $monte = ( $r['id'] == 1 ) ? '' : "\n      <input type=\"submit\" name=\"monte\" value=\"&uarr;\" title=\"Remonter l'item dans l'ordre d'apparition\">";
      if ( $r['cache'] )  {
        $cache_classe = ' cache';
        $cache_texte = "\n    <p class=\"cache\">(Cet item est caché&nbsp;: il n'apparaît pas sur la partie publique du site.)</p>";
        $cache_bouton = 'name="montre" value="Montrer" title="Montrer à nouveau l\'item, le rendre visible depuis le site public"';
      }
      else  {
        $cache_classe = $cache_texte = '';
        $cache_bouton = 'name="cache" value="Cacher" title="Cacher l\'item, le rendre invisible depuis le site public. L\'item sera encore visible ici, pour une modification ultérieure, une copie, une suppression."';
      }
      echo <<<FIN
  <div class="item admin$cache_classe">
    <h3>${r['titre']}</h3>$cache_texte
    <form class="bouton_ok" action="" method="post"><div>
      <input type="submit" name="copie" value="Recopier" title="Prendre les données de l'item et les positionner dans le formulaire comme s'il s'agissait d'un nouvel item">
      <input type="submit" name="modif" value="Modifier/Supprimer" title="Afficher l'item et demander une modification ou une suppression">
      <input type="submit" $cache_bouton>$monte
      <input type="hidden" name="nmodif" value="${r['id']}">
    </div></form>
${r['texte']}
  </div>


FIN;
    }
    $resultat->free();
  }
  else
    echo "  <h2>Il n'y actuellement aucune information enregistrée pour cette page.</h2>\n\n";
}
//////////////////
// Partie publique
else  {
  $mysqli = new mysqli($serveur,$base,$mdp,$base);
  $mysqli->set_charset('utf8');
  $resultat = $mysqli->query('SELECT titre,texte FROM infos WHERE page = '.$page['id'].' AND cache = 0');
  $mysqli->close();
  if ( $resultat->num_rows )  {
    if ( strlen($page['bandeau1']) )
      echo "  <h2>${page['bandeau1']}</h2>\n\n";
    while ( $r = $resultat->fetch_assoc() )
      echo <<<FIN
  <div class="item info">
    <h3>${r['titre']}</h3>
${r['texte']}
  </div>


FIN;
    $resultat->free();
  }
  elseif ( strlen($page['bandeau2']) )
    echo "  <h2>${page['bandeau2']}</h2>\n\n";
}

// Bas de page
include('bas.php');
?>

